import { world, system } from "@minecraft/server";

world.afterEvents.playerInteractWithBlock.subscribe(async e => {
    const { player, block, itemStack: item } = e;
    const { x, y, z } = block.location;
    const growth = block.permutation.getState('growth');
    const plants = [
        "minecraft:potatoes",
        "minecraft:carrots",
        "minecraft:beetroot",
        "minecraft:wheat"
    ];
    for (const plant of plants) {
        if (block.typeId.includes(plant) && growth == 7 && !player.hasTag('halofarming')) {
            if (item) {
                if (item.typeId == 'minecraft:bone_meal') return;
                player.addTag('halofarming');
                grow(player, x, y, z, block);
            }
            else {
                player.addTag('halofarming');
                grow(player, x, y, z, block);
            }

        }
    }
});

system.beforeEvents.watchdogTerminate.subscribe(e => e.cancel = true);

async function grow(player, x, y, z, block) {
    await player.runCommandAsync(`fill ${x} ${y} ${z} ${x} ${y} ${z} ${block.typeId} destroy`);
    player.dimension.fillBlocks(block.location, block.location, block.typeId);
    player.removeTag('halofarming');
}